#include <string.h>
#include <ctype.h>
#include <stdio.h>

#include "strlib.h"

int strn_delim_cpy(char* dest, char* src, int n,  int delim)
 {
  int i;

  for(i = 0; i < n - 1; i++)
   {
    if(!src[i] || src[i] == delim)
     {
      dest[i] = 0;
      return i;
     }
 
    dest[i] = src[i];
   }
 
  dest[i] = 0;
  return i;
 }

int strncasecmp_to_delim(char* str1, char* str2, int delim, int n)
 {
  int i;

  for(i = 0; i < n; i++)
   {
    if(!(str1[i] && str2[i]))
     return 0;
    if(str1[i] == delim || str2[i] == delim)
     return 0;

    int cmp_res = (tolower(str1[i]) - tolower(str2[i]));
    if(cmp_res)
     return cmp_res;
   }

   return 0;
 }

char** str_arg_split(char* command)
 {
  int in_quote = 0;
  //int last_is_quote = 0;
  int escaped = 0;
  int zeroed = 1;
  int i,c,j = 0;
  char* tmp_command;
  char** args;
  int arg_ind = 0;

  tmp_command = new char[strlen(command) + 2];

  for(i = 0; c = command[i]; i++)
   {
    switch(c)
     {
      case '\'':
       if(escaped)
         {
	  escaped = 0;
	  tmp_command[j++] = c;
	  continue;
	 }
       else if(in_quote)
        {
	 tmp_command[j++] = 0;
	 in_quote = 0;
	 arg_ind++;
	 continue;
	}
       else
        {
	 in_quote = 1;
	 //last_is_quote = 1;
	}
       break;
    
      case ' ':
       if(in_quote)
        {
	 escaped = 0;
	 tmp_command[j++] = c;
	 continue;
	} 
       else
        {
	 if(j > 0)
	  if(tmp_command[j - 1])
	   {
	    tmp_command[j++] = 0;
	    arg_ind++;
	   }

	 continue;
	}
       break;

      case '\\':
        if(escaped)
	 {
	  escaped = 0;
	  tmp_command[j++] = c;
	  continue;
	 }
	else
	 {
	  escaped = 1;
	  continue;
	 }

	break;

      default:
       
       escaped = 0;
       tmp_command[j++] = c;
       break; 
     }
   }
 
   if(i > 0)
    if(command[i] != ' ')
     {
      arg_ind++;
      tmp_command[j++] = 0;
     }

   //printf("j = %d, i = %d\n", j,i);
   memcpy(command, tmp_command, j);

   delete[] tmp_command;
   args = new char*[arg_ind + 1];
   int num_args = arg_ind;
   int cmd_len = j;
   
   args[0] = command;
   arg_ind = 0;
   int after_null = 1;

   for(i = 0; i < cmd_len; i++)
    {
     if(command[i])
      if(after_null)
       {
        args[arg_ind++] = command + i;
       }	 
    
      after_null = !(command[i]);
    }

   args[arg_ind] = NULL;

   return args;
 }

#ifdef TEST_STRLIB
int main()
 {
  char *test_arr[] = {"/bin/sed -e s/Microsoft/Linux/g",
  "/bin/sed -e s/Microsoft/Linux/g\n",
   "perl -e 'print \"Hello\"; '", "/bin/sed -e 's/var[ ]+urlOfNewPop/\\\\/\\\\//g'", NULL};
  int i;

  for(i = 0; test_arr[i]; i++)
   {
    char buf[1024];
    strcpy(buf, test_arr[i]);
    char** args = str_arg_split(buf);

    int j;
    printf("---------------------\n");
    for(j =  0; args[j]; j++)
     printf("%s\n", args[j]);
   }
 }
#endif
